#ifndef _FILEMENU_H_
#define _FILEMENU_H_

class FileMenu : public Menu
{
public:

	FileMenu();
	~FileMenu();

	virtual int GetNumItems();
	virtual const char * GetItemDisplayString(int index);

	// call when user selects an item; we either go into the
	// subdirectory or set the parameter to true if it's a file
	void Selected(bool *was_file_selected);
	string GetSelectedFilename();

private:

	struct item_type
	{
		string display_string;
		string filename;

		bool is_directory;

		inline bool operator<(const item_type &b) const
		{
			if (is_directory && b.is_directory == false)
				return true;
			if (is_directory == false && b.is_directory)
				return false;
			return display_string < b.display_string;
		}
	};


	vector<item_type> items;

	string current_dir;

	void FindFiles();

};

#endif
