#ifndef _MENU_H_
#define _MENU_H_

class Menu
{
public:

	Menu();
	virtual ~Menu();

	void SetPosition(int new_x,int new_y);
	void SetSize(int new_width,int new_height);
	void Draw();
	void SetFont(Font *new_font);

	// called once per frame
	void Move(bool up,bool down);

	virtual int GetNumItems();
	virtual const char * GetItemDisplayString(int index);

protected:

	void SetSelectedIndex(int new_selected_index);
	int GetSelectedIndex();

private:

	int current_item_index;

	// drawing stuff
	int x;
	int y;
	int width;
	int height;

	int row_height;

	Quad background_quad;
	Quad current_item_quad;

	int start_draw_index;

	Font *font;

	// for auto-repeat
	int frames_down;
	int frames_up;
	enum
	{
		FRAMES_INITIAL_DELAY = 12,
		FRAMES_REPEAT_DELAY = 4,
	};

	void MoveUp();
	void MoveDown();
	void SetCurrentItemQuad();
	int GetNumVisibleItems();

};

#endif
