#include "packet.h"

void InitGifPacket(GifPacket *gpkt, u128 *buffer)
{
	gpkt->begin = align128((u32*)buffer);
	gpkt->current = (u32*)gpkt->begin;
	gpkt->dmatag = NULL;
}

void ResetGifPacket(GifPacket *gpkt)
{
	gpkt->current = (u32*)gpkt->begin;
	gpkt->dmatag = NULL;
}

void  AddGSData(int index, u64 data, GifPacket *gpkt)
{
	//printf("gpkt->current = %d\n",&(gpkt->current));
	//printf("gpkt->begin = %d\n",&(gpkt->begin));
	
	gpkt->current = (u32 *)gpkt->begin + (index<<1);
	//printf("current = begin ok\n");
	//printf("current = %d\n",&(gpkt->current));
	*((u64*)gpkt->current) = data;
	//printf("current = data ok\n");
	gpkt->current += 2; // 2 = sizeof(u64)/sizeof(u32)
	//printf("end addgsdata\n");
}

u128* TerminateGifPacket(GifPacket *gpkt)
{
	u128* const dma_current = align128(gpkt->current);
	if(gpkt->dmatag)
	{
		u32 const count = (dma_current - gpkt->dmatag) - 1;
		((u32 *)gpkt->dmatag)[0] += count;
	}
	gpkt->current = (u32 *)dma_current;
	gpkt->dmatag = NULL;
	return dma_current;
}

int SizeGifPacket(GifPacket *gpkt)
{
	return ((u32)gpkt->current - (u32)gpkt->begin) >> 4;
	// >>4 = /sizeof(u128)
}

/*void OldAddGSData(GIFPacket *gpkt, u64 data)
{
	*((u64*)gpkt->current) = data;
	gpkt->current+=sizeof(u64)/sizeof(u32);
}*/