#ifndef PACKET_H
#define PACKET_H

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>

typedef unsigned int u32;
typedef unsigned long long u64;
typedef unsigned int u128 __attribute__ ((mode(TI)));

typedef struct
{
	u32 *current;
	u128 *begin;
	u128 *dmatag;
	u64 *giftag;
} GifPacket;


void  InitGifPacket(GifPacket *gpkt, u128 *buffer);

void  ResetGifPacket(GifPacket *gpkt);

void  AddGSData(int index, u64 data, GifPacket *gpkt);

u128* TerminateGifPacket(GifPacket *gpkt);

int   SizeGifPacket(GifPacket *gpkt);

inline static u128* align128(u32* pPtr)
{
	while((u32)pPtr & 0xc) *pPtr++ = 0;
	return (u128*)pPtr;
}

#endif